<template>
  <v-stepper class="elevation-0" v-model="currentStep">
    <v-stepper-header>
      <v-stepper-step :complete="currentStep > 1" step="1" color="#9652DF">
        Datos Básicos
      </v-stepper-step>

      <v-divider />

      <v-stepper-step :complete="currentStep > 2" step="2" color="#9652DF">
        Otros Datos
      </v-stepper-step>

      <v-divider />

      <v-stepper-step step="3" color="#9652DF"> Confirmación </v-stepper-step>
    </v-stepper-header>
    <v-form ref="clientRegistrationForm" v-model="clientRegistrationFormValid">
      <v-stepper-items class="tway-stepper">
        <!-- PASO 1 -->
        <v-stepper-content step="1">
          <div class="stepper-item mb-5" v-if="newCompany">
            <label>Razón Social de tu empresa</label>
            <v-text-field
              v-model="company.name"
              class="roboto"
              placeholder="Escribe aquí la Razón Social"
            />
          </div>
          <div class="stepper-item mb-2">
            <label>¿Cuál es tu negocio principal?</label>
            <v-tooltip bottom class="tooltip">
              <template v-slot:activator="{ on }">
                <v-icon small v-on="on" class="ml-auto icono">
                  mdi-information-outline
                </v-icon>
              </template>
              <span v-if="!newCompany" class="sii roboto"
                >Dato entregado por el SII</span
              >
              <span v-if="newCompany" class="sii roboto"
                >Revisa la actividad económica de tu empresa para saber tu
                negocio principal.</span
              >
            </v-tooltip>
            <v-select
              v-if="sectorSet"
              v-model="company.industrialSector"
              :items="availableIndustrialSectors"
              item-text="name"
              :disabled="sectorSet"
              attach
              chips
              class="roboto"
            />
            <v-select
              v-else
              v-model="company.industrialSector"
              :items="availableIndustrialSectors"
              item-text="name"
              :disabled="sectorSet"
              attach
              chips
              label="Selecciona un Sector"
              class="roboto"
            />
          </div>
          <div class="separator mb-6" />
          <div class="stepper-item mb-6">
            <label>Cuéntanos acerca de tu empresa</label>
            <v-textarea
              v-model="company.contributionValue"
              rows="3"
              no-resize
              placeholder="Breve descripción sobre tu producto o servicio que ofreces"
              hide-details
              class="roboto"
            />
          </div>
          <div class="separator mb-6" />
          <div class="stepper-item mb-5">
            <label>¿Desde qué año está activa tu empresa?</label>
            <v-tooltip bottom class="tooltip">
              <template v-slot:activator="{ on }">
                <v-icon small v-on="on" class="icono">
                  mdi-information-outline
                </v-icon>
              </template>
              <span v-if="!newCompany" class="sii roboto"
                >Dato entregado por el SII</span
              >
              <span v-if="newCompany" class="sii roboto"
                >Ingresa el año donde tu empresa comenzó actividades en el
                SII</span
              >
            </v-tooltip>
            <v-text-field
              v-model="company.trajectory"
              :disabled="yearSet"
              :rules="[validYear()]"
              maxlength="4"
              class="roboto"
              required
            />
          </div>

          <v-row class="pa-0 ma-0 mb-5" justify="center" align="center">
            <div class="d-inline roboto mr-2">
              <v-btn
                class="
                  text-lowercase text-decoration-underline text-body-1
                  roboto
                  lower
                "
                rounded
                text
                x-small
                color="deep-purple accent-4"
                @click="goBack"
              >
                <capital>completar más tarde</capital>
              </v-btn>
            </div>
            <div class="d-inline">
              <v-btn
                depressed
                rounded
                class="button-text tway-violet white--text roboto elevation-3"
                @click="updateProfile(2)"
                id="profile-nextstep-2"
              >
                Siguiente
              </v-btn>
            </div>
          </v-row>
        </v-stepper-content>
        <!-- PASO 2 -->
        <v-stepper-content step="2">
          <div class="stepper-item mb-5">
            <label>Tamaño</label>
            <v-tooltip bottom class="tooltip">
              <template v-slot:activator="{ on }">
                <v-icon small v-on="on" class="ml-auto icono">
                  mdi-information-outline
                </v-icon>
              </template>
              <span v-if="!newCompany" class="sii roboto"
                >Dato entregado por el SII</span
              >
              <span v-if="newCompany" class="sii roboto"
                >El tamaño está definido según el rango de facturación de tu
                empresa.</span
              >
            </v-tooltip>
            <v-select
              v-if="newCompany"
              class="subtitle-2 roboto"
              v-model="company.size"
              :items="availableSizes"
              :item-text="
                (availableSizes) =>
                  `${availableSizes.name} ${availableSizes.salesUfRange}`
              "
              placeholder="Selecciona un tamaño acorde a tu empresa"
              return-object
            />
            <v-select
              v-else
              class="subtitle-2 roboto"
              v-model="company.size"
              :disabled="sizeSet"
              :items="availableSizes"
              :item-text="textRange"
              persistent-hint
              hint="(No compartiremos tu información de facturación)"
              placeholder="Selecciona un tamaño acorde a tu empresa"
              return-object
            />
          </div>
          <div class="stepper-item mb-5" v-if="newCompany">
            <label>Cantidad de trabajadores</label>
            <v-text-field
              v-model="company.workers"
              class="roboto"
              :rules="[ValidWorkers()]"
              placeholder="Ingresa la cantidad total de trabajadores (sin puntos ni comas)"
              min="1"
            />
          </div>
          <div class="separator mb-6" />
          <div class="stepper-item mb-5">
            <label>Sitio Web</label>
            <v-text-field
              class="subtitle-2 roboto"
              v-model="company.web"
              placeholder="Ingresa el sitio web de tu empresa"
            />
          </div>
          <div class="separator mb-6" />
          <div class="stepper-item mb-5">
            <label>Perfil Linkedin</label>
            <v-text-field
              class="subtitle-2 roboto"
              v-model="company.linkedIn"
              placeholder="Ingresa el link del perfil de LinkedIn de tu empresa"
            />
          </div>
          <v-row class="pa-0 ma-0 mb-5" justify="center" align="center">
            <v-col
              class="pa-0 ma-0"
              cols="3"
              xs="3"
              sm="3"
              md="2"
              lg="2"
              xl="2"
            >
              <v-btn
                outlined
                color="deep-purple accent-4"
                class="button-text"
                rounded
                @click="currentStep = 1"
                id="profile-nextstep-back"
              >
                Atrás
              </v-btn>
            </v-col>
            <v-col
              class="pa-0 ma-0"
              cols="3"
              xs="3"
              sm="3"
              md="2"
              lg="2"
              xl="2"
            >
              <v-btn
                depressed
                rounded
                class="button-text tway-violet white--text"
                @click="updateProfile(3)"
                id="profile-nextstep-3"
              >
                Siguiente
              </v-btn>
            </v-col>
          </v-row>
          <v-row class="pa-0 ma-0 mb-5" justify="center" align="center">
            <div :class="mobile ? 'text-center' : 'text-left'">
              <v-btn
                class="
                  text-lowercase text-decoration-underline text-body-1
                  roboto
                  mt-2
                  lower
                "
                text
                small
                color="tway-purple"
                @click="goBack"
              >
                <capital>completar más tarde</capital>
              </v-btn>
            </div>
          </v-row>
        </v-stepper-content>
        <!-- PASO 3 -->
        <v-stepper-content step="3">
          <v-row v-if="company.name && newCompany" class="stepper-item mb-3">
            <v-col>
              <div class="h6">Razón Social</div>
              <div>
                <a class="subtitle-2 roboto" style="color: #999999">{{
                  company.name
                }}</a>
              </div>
            </v-col>
          </v-row>
          <div
            v-if="company.industrialSector && newCompany"
            class="separator mb-6"
          />
          <div v-if="company.industrialSector" class="stepper-item mb-5">
            <div class="h6">Negocio Principal</div>
            <div class="subtitle-2 roboto" style="color: #999999">
              {{ company.industrialSector }}
            </div>
          </div>
          <div v-if="company.contributionValue" class="separator mb-6" />
          <div v-if="company.contributionValue" class="stepper-item mb-5">
            <div class="h6">Acerca de la Empresa</div>
            <div class="subtitle-2 roboto" style="color: #999999">
              {{ company.contributionValue }}
            </div>
          </div>
          <div v-if="company.trajectory" class="separator mb-6" />
          <div v-if="company.trajectory" class="stepper-item mb-5">
            <div class="h6">Inicio Actividades</div>
            <div class="subtitle-2 roboto" style="color: #999999">
              {{ company.trajectory }}
            </div>
          </div>
          <div v-if="company.size" class="separator mb-6" />
          <v-row v-if="company.size" class="stepper-item mb-3">
            <v-col>
              <div class="h6">Tamaño</div>
              <div>
                <a
                  class="subtitle-2 roboto"
                  style="color: #999999"
                  v-if="company.size"
                  >{{ company.size.name }} {{ company.size.salesUfRange }}</a
                >
              </div>
            </v-col>
          </v-row>
          <div v-if="company.workers" class="separator mb-6" />
          <v-row v-if="company.workers" class="stepper-item mb-3">
            <v-col>
              <div class="h6">Cantidad de Trabajadores</div>
              <div>
                <a class="subtitle-2 roboto" style="color: #999999">{{
                  company.workers
                }}</a>
              </div>
            </v-col>
          </v-row>
          <div v-if="company.web" class="separator mb-6" />
          <v-row v-if="company.web" class="stepper-item mb-5">
            <v-col>
              <div>
                <div class="h6">Sitio Web</div>
                <div>
                  <a
                    target="_blank"
                    class="subtitle-2 roboto"
                    style="color: #999999"
                    v-if="company.web !== ''"
                    :href="'http://' + company.web"
                    >{{ company.web }}</a
                  >
                </div>
              </div>
            </v-col>
          </v-row>
          <div v-if="company.linkedIn" class="separator mb-6" />
          <v-row v-if="company.linkedIn" class="stepper-item mb-5">
            <v-col>
              <div>
                <div class="h6">Perfil Linkedin</div>
                <div>
                  <a
                    class="subtitle-2 roboto"
                    style="color: #999999"
                    target="_blank"
                    v-if="company.linkedIn !== ''"
                    :href="'http://' + company.linkedIn"
                    >{{ company.linkedIn }}</a
                  >
                </div>
              </div>
            </v-col>
          </v-row>
          <v-row v-if="siiAlert" class="pa-0 ma-0">
            <v-alert color="red" dense type="error">
              Debe completar los datos de Sector, Año de actividad, Tamaño y
              cantidad de trabajadores para completar el perfilamiento.
            </v-alert>
          </v-row>
          <v-row
            :class="mobile ? '' : 'ml-9'"
            class="pa-0 ma-0 mb-5"
            justify="center"
          >
            <v-col
              class="pa-0 ma-0"
              cols="3"
              xs="2"
              sm="2"
              md="2"
              lg="2"
              xl="2"
            >
              <v-btn
                outlined
                color="deep-purple accent-4"
                class="button-text"
                rounded
                @click="currentStep = 2"
                id="profile-nextstep-back-from-complete"
              >
                Atrás
              </v-btn>
            </v-col>
            <v-col
              class="pa-0 ma-0"
              cols="6"
              xs="6"
              sm="6"
              md="4"
              lg="4"
              xl="4"
            >
              <v-btn
                depressed
                rounded
                class="button-text tway-violet white--text"
                :to="{ name: 'my-profile' }"
                id="profile-nextstep-complete"
              >
                Confirmar mi perfil
              </v-btn>
            </v-col>
          </v-row>
          <v-row class="pa-0 ma-0 mb-5" justify="center" align="center">
            <div :class="mobile ? 'text-center' : 'text-left'">
              <v-btn
                class="
                  text-lowercase text-decoration-underline text-body-1
                  roboto
                  mt-2
                  lower
                "
                text
                small
                color="tway-purple"
                @click="goBack"
              >
                <capital>completar más tarde</capital>
              </v-btn>
            </div>
          </v-row>
        </v-stepper-content>
      </v-stepper-items>
    </v-form>
  </v-stepper>
</template>
<style lang="scss" scoped>
.v-stepper__header {
  box-shadow: none !important;
}
.border:after {
  position: absolute;
  top: 20%;
  left: 0;
  width: 1px;
  height: 60%;
  background: #cccccc;
}
.border2-desk {
  background: url("../../assets/img/Line5.png") top no-repeat;
}
.border2-mobile {
  background: url("../../assets/img/Line4.png") top no-repeat;
}
.border {
  background: url("../../assets/img/Line2.png") left no-repeat;
}
.lower {
  text-transform: initial;
}
.stepper-btn-group *:not(:last-child) {
  margin-right: 20px;
}
.separator {
  border: 1px solid #f1f1f1;
  width: 100%;
}
.select-subtitle {
  font-size: 16px;
  line-height: 24px;
  color: #cccccc;
}
capital {
  text-transform: lowercase;
}

capital::first-letter {
  text-transform: uppercase;
}

.icono {
  width: 38px;
  color: #4a148c;
  top: -2px;
  font-size: 18px !important;
}

.sii {
  color: white;
}
.tooltip {
  color: #4a148c;
}
</style>

<script>
import companyService from "@/services/companyService";

export default {
  name: "ClientRegistration",

  props: {
    companyData: {
      type: Object,
      required: true,
    },
  },

  data() {
    return {
      clientRegistrationFormValid: false,
      company: {
        name: "",
        industrialSector: {
          name: "",
        },
        trajectory: "",
        size: {
          name: "",
        },
        web: "",
        linkedIn: "",
      },
      currentStep: 1,
      yearSet: false,
      sectorSet: false,
      sizeSet: false,
      newCompany: false,
      siiAlert: false,
      availableServices: [],
      availableIndustrialSectors: [],
      availableSizes: [],
    };
  },

  created() {
    this.company = this.companyData;
    if (this.company.trajectory && this.company.checked) {
      this.yearSet = true;
    }
    if (this.company.size && this.company.checked) {
      this.sizeSet = true;
    }
    if (this.company.industrialSector) {
      this.company.industrialSector = this.company.industrialSector.name;
      if (this.company.checked) {
        this.sectorSet = true;
      }
    }
    if (!this.company.checked) {
      this.newCompany = true;
    } else {
      this.newCompany = false;
    }

    let userInfo = JSON.parse(localStorage.getItem("userInfo"));
    let clientId = "";
    if (userInfo && userInfo.principal && userInfo.principal.clientId) {
      clientId = userInfo.principal.clientId;
    }

    if (clientId) {
      companyService
        .getSectors(clientId)
        .then((response) => {
          this.availableIndustrialSectors = response;
        })
        .catch((err) => this.$log.error(err));
      companyService
        .getSizes(clientId)
        .then((response) => {
          this.availableSizes = response;
        })
        .catch((err) => this.$log.error(err));
    }
  },

  methods: {
    updateProfile(step) {
      if (this.$refs.clientRegistrationForm.validate()) {
        let data = this.company;

        companyService
          .updateCompanyProfile(data)
          .then(() => (this.currentStep = step))
          .catch((err) => this.$log.error(err));
      }
    },

    validYear() {
      const pattern = new RegExp("^\\d{4}$");
      const currentYear = new Date().getFullYear();

      return (v) => {
        if (v) {
          return (
            (pattern.test(v) && parseInt(v) <= currentYear && v > 1000) ||
            "Debes ingresar un formato de año válido"
          );
        }

        return true;
      };
    },

    ValidWorkers() {
      const pattern = new RegExp("^([0-9_])+$");
      return (v) => {
        if (v) {
          return (
            (v > 0 && pattern.test(v)) ||
            "Debes ingresar la cantidad de trabajadores valida"
          );
        }
        return true;
      };
    },

    goBack() {
      this.$router.go(-1);
    },

    textRange() {
      return this.company.size.name + " " + this.company.size.salesUfRange;
    },
  },
  watch: {
    currentStep() {
      if (this.currentStep > 1) {
        this.$emit("hide", true);
      } else {
        this.$emit("hide", false);
      }
    },
  },
  computed: {
    mobile() {
      return this.$vuetify.breakpoint.sm || this.$vuetify.breakpoint.xs;
    },
    desktop() {
      return (
        this.$vuetify.breakpoint.md ||
        this.$vuetify.breakpoint.lg ||
        this.$vuetify.breakpoint.xl
      );
    },
  },
};
</script>
